"use strict";require("core-js/modules/es.array.iterator");Object.defineProperty(exports,"__esModule",{value:true});exports.cartesianIterate=exports.cartesianArray=void 0;

const cartesianArray=function(...arrays){
if(arrays.length===0){
return[];
}

arrays.forEach(validateArray);

const loopFunc=getLoopFunc(arrays.length,false);
const result=[];
loopFunc(arrays,result);
return result;
};exports.cartesianArray=cartesianArray;




const cartesianIterate=function*(...arrays){
if(arrays.length===0){
return;
}

arrays.forEach(validateArray);

const loopFunc=getLoopFunc(arrays.length,true);
yield*loopFunc(arrays);
};exports.cartesianIterate=cartesianIterate;

const validateArray=function(array){
if(!Array.isArray(array)){
throw new TypeError(`Argument must be an array: ${array}`);
}
};

const getLoopFunc=function(length,iterable){
const cachedLoopFunc=cache[iterable][length];

if(cachedLoopFunc!==undefined){
return cachedLoopFunc;
}

const loopFunc=mGetLoopFunc(length,iterable);

cache[iterable][length]=loopFunc;
return loopFunc;
};

const cache={false:{},true:{}};











const mGetLoopFunc=function(length,iterable){
const indexes=Array.from({length},getIndex);
const repeatA=repeat.bind(null,indexes);

const start=repeatA(
index=>`for (const value${index} of arrays[${index}]) {`);

const middle=repeatA(index=>`value${index}`,", ");
const end=repeatA(()=>"}");

if(iterable){
return new GeneratorFunction("arrays",`${start} yield [${middle}] ${end}`);
}


return new Function(
"arrays",
"result",
`${start}\nresult.push([${middle}])\n${end}`);

};

const getIndex=function(value,index){
return String(index);
};

const repeat=function(indexes,mapper,separator="\n"){
return indexes.map(mapper).join(separator);
};


const GeneratorFunction=cartesianIterate.constructor;
//# sourceMappingURL=main.js.map